// Gamma_CorrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Gamma_Corr.h"
#include "Gamma_CorrDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGamma_CorrDlg dialog

CGamma_CorrDlg::CGamma_CorrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGamma_CorrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGamma_CorrDlg)
	m_fGamma = 1.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGamma_CorrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGamma_CorrDlg)
	DDX_Text(pDX, IDC_GAMMA, m_fGamma);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGamma_CorrDlg, CDialog)
	//{{AFX_MSG_MAP(CGamma_CorrDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_MOUSEWHEEL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGamma_CorrDlg message handlers

BOOL CGamma_CorrDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGamma_CorrDlg::OnPaint() 
{	
	CPaintDC dc(this); // device context for painting
	CRect rect;
	GetClientRect(&rect);

	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		/// DrawGradation
		SIZE sizeRect;
		POINT ptRef;
		sizeRect.cx = 2;
		sizeRect.cy = 20;
		ptRef.x = 10;
		ptRef.y = 50;

		DrawGradation(dc, ptRef, sizeRect);

		/// DrawGraph
		ptRef.x = 10;
		ptRef.y = 100;
		DrawGraph(dc, ptRef, sizeRect.cx);



		CDialog::OnPaint();
	}
}

void CGamma_CorrDlg::DrawGradation(CDC &dc, POINT &ptRef, SIZE &sizeRect)
{
	int i;
	int x;

	for(i = 0; i < 0x100; i++)
	{
		x = ptRef.x + sizeRect.cx * i;
		dc.FillSolidRect(x, ptRef.y, sizeRect.cx, sizeRect.cy, GetCorrectedGray(i));
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGamma_CorrDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

COLORREF CGamma_CorrDlg::GetCorrectedGray(int idx)
{
	int new_idx;
	new_idx = pow(idx, 1/m_fGamma)*0x100/pow(0x100, 1/m_fGamma);

	return new_idx*0x010101;
}

void CGamma_CorrDlg::DrawGraph(CDC &dc, POINT &ptRef, UINT cx)
{
	POINT ptPixel;
	int x = 0;

	ptPixel.x = ptRef.x + x*cx;
	ptPixel.y = ptRef.y + cx*GetCorrectedGray(x)/0x010101;
	
	dc.MoveTo(ptPixel);

	x++;


	for(; x < 0x100; x++)
	{
		ptPixel.x = ptRef.x + x*cx;
		ptPixel.y = ptRef.y + cx*GetCorrectedGray(x)/0x010101;
		dc.LineTo(ptPixel);
		//dc.SetPixel(ptPixel, 0x00FFFFFF);
	}
	
}

BOOL CGamma_CorrDlg::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	// TODO: Add your message handler code here and/or call default
	if(zDelta > 0)
	{
		m_fGamma += 0.125;
	} else {
		m_fGamma -= 0.125;
		if(m_fGamma <0)
			m_fGamma = 0;
	}

	UpdateData(FALSE);
	Invalidate();

	return CDialog::OnMouseWheel(nFlags, zDelta, pt);
}
